#include<avr/io.h>
#include<avr/interrupt.h>

#define RC (((PIND>>3)^0x01)&0x01) //MW[̐M

#define TOSHIBA     0xbf40 //ł̃[J[R[h

//R̊e{^̒l//
#define CH_1        0x01
#define CH_2        0x02
#define CH_3        0x03
#define CH_4        0x04
#define CH_5        0x05
#define CH_6        0x06
#define CH_7        0x07
#define CH_8        0x08
#define CH_9        0x09
#define CH_10       0x0a
#define CH_11       0x0b
#define CH_12       0x0c
#define CH_UP       0x1b
#define CH_DOWN     0x1f
#define VOL_UP      0x1a
#define VOL_DOWN    0x1e
#define VOL_OFF     0x10
#define IN_CHANGE   0x0f
#define VCC_ON      0x12
//////////////////////////

#define Forward     0x02
#define Back        0x01
#define Stop        0x03

uint8_t  i,time;
uint8_t  data=0,data_old=0;
uint16_t data_tmp,m_code,t1,t0;
uint16_t et=1000; //ُȐMĂƂɃvO
                  //~̂h߂̎

ISR(INT1_vect){ //MW[̐Mǂ񂾂犄荞
    data_tmp=0;
    m_code=0;

    //[_R[h̓ǂݎ
    t1=t0=0;
    while(RC==1&&t1<et) t1++;
    while(RC==0&&t0<et) t0++;

    if(t1<t0*3&&t1>t0){ //[_R[hƔf
        //[J[R[h̓ǂݎ
        for(i=0;i<16;i++){
            t1=t0=0;
            while(RC==1&&t1<et) t1++;
            while(RC==0&&t0<et) t0++;
            if(t1*2<t0&&t1*4>t0) m_code|=0x01<<i; //f[^Pł
        }
        //f[^R[h̓ǂݎ
        for(i=0;i<16;i++){
            t1=t0=0;
            while(RC==1&&t1<et) t1++;
            while(RC==0&&t0<et) t0++;
            if(t1*2<t0&&t1*4>t0) data_tmp|=0x01<<i; //f[^Pł
        }
        //f[^R[h̃G[`FbN[J[R[hł`FbN
        //f[^ȂdataXVAȂȂdata
        if(((data_tmp&0x00ff)==((data_tmp>>8)^0x00ff))&&(m_code==TOSHIBA)){
            data=data_tmp&0x00ff;
            data_old=data;
        }else{
            data=data_old=0;
        }
        //XgbvrbgI܂ő҂
        t1=0;
        while(RC==1&&t1<et) t1++;
        time=0;
    }else if(t1<t0*5&&t1>t0*3){ //s[gR[hƔf
        //XgbvrbgI܂ő҂
        t1=0;
        while(RC==1&&t1<et);
        time=0;
        data=data_old;
    }
}

//[^[֐
void motor(uint8_t lm,uint8_t rm){
    PORTB=(((lm&0x03)<<2)|(rm&0x03))&0x0f;
}

void wait(uint16_t t){
    while(t--);
}

int main(void){
    //Osݐݒ
    GIMSK=0x80;

    //|[g̓o͐ݒ
    DDRD=0x03;
    DDRB=0xff;
    DDRD=0xf7;

    //{bg̏
    motor(Stop,Stop);

    //Ŝ̊݋
    sei();

    while(1){
        //ԃRMĂȂȂdataZbg
        if(time>200) data=0; else time++;

        //e{^ɉ
        switch(data){   
            case CH_2:
            case CH_UP:
                motor(Forward,Forward);
                break;
            case CH_8:
            case CH_DOWN:
                motor(Back,Back);
                break;
            case CH_6:            
            case VOL_UP:
                motor(Forward,Back);
                break;
            case CH_4:
            case VOL_DOWN:
                motor(Back,Forward);
                break;
            case CH_3:
            case IN_CHANGE:
                motor(Forward,Stop);
                break;
            case CH_1:
            case VCC_ON:
                motor(Stop,Forward);
                break;
            case CH_9:
                motor(Back,Stop);
                break;
            case CH_7:
                motor(Stop,Back);
                break;
            default:
                motor(Stop,Stop);
                break;
        }
    }
}
